//+------------------------------------------------------------------+
//|                                                   delta-stop.mq4 |
//|                Copyright  2006, Nick Bilak, beluck[AT]gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright c 2006, Nick Bilak"
#property link      "http://www.mql4.info/"

#property indicator_chart_window
#property indicator_buffers 5

#property indicator_color1 Blue
#property indicator_color2 MediumBlue
#property indicator_color3 FireBrick
#property indicator_color4 Maroon

#property indicator_color5 Red

#property indicator_style1     4
#property indicator_style2     2
#property indicator_style3     4
#property indicator_style4     2
//---- input parameters
extern bool    atrMode=1; //0 - auto, 1 - manual
extern double  DeltaPrice=50;
extern int     ATRperiod=500;
extern double  ATRratio=3.522;
double buf[];
double buf1[];
double buf2[];
double buf3[];
double buf4[];
double atr[];
double atrs[];

int init()  {
   IndicatorBuffers(7);
   
   SetIndexStyle (0,DRAW_LINE);
   SetIndexBuffer(0,buf1);
   SetIndexStyle (1,DRAW_LINE);
   SetIndexBuffer(1,buf2);
  
   SetIndexStyle (2,DRAW_LINE);
   SetIndexBuffer(2,buf3);
   SetIndexStyle (3,DRAW_LINE);
   SetIndexBuffer(3,buf4);
  
   SetIndexStyle (4,DRAW_LINE);
   SetIndexBuffer(4,buf);

   SetIndexBuffer(5,atr);
   SetIndexBuffer(6,atrs);
   SetIndexEmptyValue(5,0);
   SetIndexEmptyValue(6,0);


   return(0);
}


int start() {


   int counted_bars=IndicatorCounted();
   int shift,limit,i,k;
   double TrStopLevel,DeltaStop;
   
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit=Bars-ATRperiod*2-1;
   //if(counted_bars>=ATRperiod) limit=Bars-counted_bars-1;

   if (atrMode) { 
      for (i=limit+ATRperiod+1;i>=0;i--) {
         atr[i]=iATR(NULL,0,ATRperiod,i);
      }
      for (i=limit;i>=0;i--) {
         atrs[i]=iMAOnArray(atr,0,ATRperiod,0,MODE_SMMA,i);
      }
   }
   else DeltaStop=DeltaPrice;

   for (shift=limit;shift>=0;shift--)   {
      if (atrMode) DeltaStop=atrs[shift] * ATRratio; else DeltaStop=DeltaPrice*Point;
      if (Close[shift]==buf[shift+1]) buf[shift] = buf[shift+1];
      else if (Close[shift+1]<=buf[shift+1] && Close[shift]<buf[shift+1]) buf[shift]=MathMin(buf[shift+1],Close[shift]+DeltaStop);
      else if (Close[shift+1]>=buf[shift+1] && Close[shift]>buf[shift+1]) buf[shift]=MathMax(buf[shift+1],Close[shift]-DeltaStop);
      else if (Close[shift]>buf[shift+1]) buf[shift]=Close[shift]-DeltaStop;
      else buf[shift]=Close[shift]+DeltaStop;
      buf1[shift]=buf[shift]+DeltaStop;   buf2[shift]=buf[shift]+2*DeltaStop;   
      buf3[shift]=buf[shift]-DeltaStop;   buf4[shift]=buf[shift]-2*DeltaStop;   
   }
   return(0);
}


